/* -*- mode: c -*- */
/* $Id: koi8_to_enc_heap.c,v 1.1 2002/11/29 07:36:07 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "nls.h"

#include <reuse/xalloc.h>

#include <string.h>
#include <stdlib.h>

unsigned char *
str_koi8_to_enc_heap(const struct nls_table *enc, unsigned char const *in)
{
  unsigned char *buf;
  int len;

  if (!enc->is_singlebyte) {
    // oops.
    abort();
  }

  if (!in) return xstrdup("");
  len = strlen(in);
  buf = alloca(len + 7);
  str_koi8_to_enc_unchecked(enc, buf, in);
  return xstrdup(buf);
}

/**
 * Local variables:
 *  compile-command: "make"
 *  c-font-lock-extra-types: ("\\sw+_t" "FILE")
 *  eval: (set-language-environment "Cyrillic-KOI8")
 * End:
 */
