/* -*- mode: c -*- */
/* $Id: nls.c,v 1.3 2002/10/08 04:53:04 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "nls.h"

#include <string.h>

extern struct nls_table *nls_table_koi8_r;
extern struct nls_table *nls_table_utf8;
extern struct nls_table *nls_table_cp1251;
extern struct nls_table *nls_table_cp866;
extern struct nls_table *nls_table_iso8859_5;

struct nls_table *
nls_lookup_table(const char *name)
{
  struct nls_table *tab = 0;

  if (!strcasecmp(name, "koi8-r") || !strcasecmp(name, "koi8-ru")) {
    tab = nls_table_koi8_r;
  } else if(!strcasecmp(name, "microsoft-1251")
            || !strcasecmp(name, "windows-1251")
            || !strcasecmp(name, "cp1251")) {
    tab = nls_table_cp1251;
  } else if (!strcasecmp(name, "cp866")) {
    tab = nls_table_cp866;
  } else if (!strcasecmp(name, "iso8859-5")) {
    tab = nls_table_iso8859_5;
  }
  return tab;
}

/**
 * Local variables:
 *  compile-command: "make"
 *  c-font-lock-extra-types: ("\\sw+_t" "FILE")
 *  eval: (set-language-environment "Cyrillic-KOI8")
 * End:
 */
