/* -*- mode: c -*- */
/* $Id: utf8_to_enc_unchecked.c,v 1.1 2002/11/29 07:36:43 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "nls.h"

#include <reuse/xalloc.h>

#include <string.h>
#include <stdlib.h>

extern struct nls_table *nls_table_utf8;

int
str_utf8_to_enc_unchecked(const struct nls_table *enc,
                          unsigned char *buf,
                          unsigned char const *in)
{
  int outlen = 0;
  unsigned char cb, cul, cuh;
  int o;

  if (!enc->is_singlebyte) {
    // oops.
    abort();
  }

  while (*in) {
    nls_table_utf8->char2uni(in, &o, &cul, &cuh);
    in += o;
    enc->uni2char(cuh, cul, &cb, 1, &o);
    buf[outlen++] = cb;
  }

  buf[outlen] = 0;
  return outlen;
}

/**
 * Local variables:
 *  compile-command: "make"
 *  c-font-lock-extra-types: ("\\sw+_t" "FILE")
 *  eval: (set-language-environment "Cyrillic-KOI8")
 * End:
 */
