/* -*- c -*- */
/* $Id: make-teamdb-inet.c,v 1.2 2001/10/05 22:54:48 cher Exp $ */

/* Copyright (C) 2001 Alexander Chernov <cher@ispras.ru> */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "inetdb.h"

#include <stdio.h>

int
main(int argc, char *argv[])
{
  struct inetdb *db;
  int dbsize, i;
  char *login, *name;

  if (argc != 2) {
    printf("Usage: make-teamdb-inet <inetdb>\n");
    return 0;
  }

  if (!(db = read_inetdb(argv[1]))) return 1;
  dbsize = inetdb_id_size(db);

  for (i = 0; i < dbsize; i++) {
    if (inetdb_get_index(db, i) < 0) continue;
    name = inetdb_get_name(db, i);
    login = inetdb_get_login(db, i);
    printf("%s:%d::%s\n", login, i, name);
  }

  return 0;
}

/**
 * Local variables:
 *  compile-command: "make"
 *  c-font-lock-extra-types: ("\\sw+_t" "FILE")
 * End:
 */

