/* -*- mode: c -*- */

#ifndef __NLS_H__
#define __NLS_H__

/* $Id: nls.h,v 1.4 2002/12/02 05:46:53 cher Exp $ */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

struct nls_unicode {
	unsigned char uni1;
	unsigned char uni2;
};

struct nls_table {
	char *charset;
        int is_singlebyte;
	void (*uni2char) (unsigned char ch, unsigned char cl, unsigned char *out, int boundlen, int *outlen);
	void (*char2uni) (const unsigned char *rawstring, int *offset, unsigned char *uni1, unsigned char *uni2);
        int (*unilen)(unsigned char ch, unsigned char cl);

	struct nls_table *next;
};

extern struct nls_table *nls_table_koi8_r;
extern struct nls_table *nls_table_utf8;
extern struct nls_table *nls_table_cp1251;
extern struct nls_table *nls_table_cp866;
extern struct nls_table *nls_table_iso8859_5;

struct nls_table *nls_lookup_table(char const *table_name);

int str_utf8_to_enc(const struct nls_table *enc,
                    unsigned char *buf, int size, unsigned char const *in);
int str_utf8_to_enc_unchecked(const struct nls_table *enc,
                              unsigned char *buf,
                              unsigned char const *in);
unsigned char *str_utf8_to_enc_heap(const struct nls_table *enc,
                                    unsigned char const *in);

int str_utf8_to_koi8(unsigned char *buf, int size, unsigned char const *in);
int str_utf8_to_koi8_unchecked(unsigned char *buf, unsigned char const *in);
unsigned char *str_utf8_to_koi8_heap(unsigned char const *in);

int str_koi8_to_enc(const struct nls_table *enc,
                    unsigned char *buf, int size, unsigned char const *in);
unsigned char * str_koi8_to_enc_heap(const struct nls_table *enc,
                                     unsigned char const *in);
int str_koi8_to_enc_unchecked(const struct nls_table *enc,
                              unsigned char *buf, unsigned char const *in);

#endif /* __NLS_H__ */
